﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Oni;

namespace OniMatrix
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
            ShowMatrix(Matrix.Identity);
        }

        private void tb_TextChanged(object sender, EventArgs a)
        {
            var t = new Vector3((float)tbTx.Value, (float)tbTy.Value, (float)tbTz.Value);
            var e = new Vector3((float)tbRx.Value, (float)tbRy.Value, (float)tbRz.Value);
            var q = Quaternion.CreateFromEulerXYZ(e);
            var m = Matrix.CreateFromQuaternion(q);
            m.Translation = t;

            ShowMatrix(m);
        }

        private void ShowMatrix(Matrix m)
        {
            var s = new StringBuilder();
            s.AppendFormat("{0:f6}  {1:f6}  {2:f6}", m.M11, m.M12, m.M13);
            s.AppendLine();
            s.AppendFormat("{0:f6}  {1:f6}  {2:f6}", m.M21, m.M22, m.M23);
            s.AppendLine();
            s.AppendFormat("{0:f6}  {1:f6}  {2:f6}", m.M31, m.M32, m.M33);
            s.AppendLine();
            s.AppendFormat("{0:f6}  {1:f6}  {2:f6}", m.M41, m.M42, m.M43);
            s.AppendLine();
            tbMatrix.Text = s.ToString();
        }
    }
}
